import { merge } from '@vue-formily/util';
import Form from './core/elements/Form';
const defaultOptions = {
  alias: 'forms'
};
export default class Formily {
  constructor(options = {}, $root) {
    this.options = merge({}, defaultOptions, options);
    this.$root = $root;
  }

  addForm(schema) {
    const {
      options
    } = this;
    const {
      rules
    } = schema;
    schema.rules = merge([], options.rules, rules);
    const form = new Form(schema);
    this.$root.$set(this.$root[options.alias], form.formId, form);
    return form;
  }

  removeForm(formId) {
    delete this.$root[this.options.alias][formId];
  }

  getForm(formId) {
    return this.$root[this.options.alias][formId];
  }

}