import { isFunction } from '@vue-formily/util';
export function normalizeRules(rules = [], type = null) {
  const _rules = [];
  rules.forEach(rule => {
    /**
     * Only apply validation rule to 'function' or 'undefined' or field that has type is included in 'types' property of the rule
     */
    if (isFunction(rule) || !rule.for || type && rule.for.includes(type)) {
      _rules.push(rule);
    }
  });
  return _rules;
}
export function invalidateSchemaValidation(sv, reason, infos) {
  sv.valid = false;
  sv.reason = reason;
  sv.infos = infos;
}
export function getSchemaAcceptance(schema, type) {
  const sv = {
    valid: false
  };
  const i = {
    accepted: false,
    sv
  };

  if ('_is' in schema) {
    i.accepted = true;

    if (schema._is === type) {
      sv.valid = true;
    }
  } else {
    sv.valid = true;
  }

  return i;
}
export function acceptSchema(schema, type) {
  schema._is = type;
}