import { Field, Group, Collection, Form } from './core/elements';
import Formily from './Formily';
import Objeto from './core/Objeto';
import Evento from './core/Evento';
import { def } from './utils';

const _configs = new WeakMap();

function createFormily() {
  const config = {
    plugs: {},
    elements: []
  };
  const elements = config.elements;
  const proto = Objeto.prototype;
  def(proto, '_config', {
    get() {
      return _configs.get(vueFormily);
    }

  });
  def(proto, 'plugs', {
    get() {
      return this._config.plugs;
    }

  });
  const vueFormily = {
    install(app, options = {}) {
      // initialize default form elements
      [Field, Collection, Group].forEach(F => this.register(F, options));
      app.mixin({
        beforeCreate() {
          this.$formily = new Formily(options, this.$root);
        },

        data() {
          const alias = this.$formily.options.alias;
          let forms = this.$root[alias];

          if (!forms) {
            forms = this.$root[alias] = {};
          }

          return {
            [alias]: forms
          };
        }

      });
    },

    plug(plugin, ...args) {
      plugin.install(config, ...args);
    },

    register(F, ...args) {
      if (!elements.includes(F)) {
        elements.unshift(F);
      }

      F.register(...args);
    }

  };

  _configs.set(vueFormily, config);

  return vueFormily;
}

const VueFormily = {
  createFormily
};
export * from './core/validations';
export { Field, Group, Collection, Form, Objeto, Formily, Evento };
export { defineSchema } from './defineSchema';
export { createFormily, VueFormily };
export default VueFormily;